================
Cython Changelog
================

0.29.36 (2023-07-04)
====================

Bugs fixed
----------

* Async generators lost their return value in PyPy.
  (Github issue :issue:`5465`)

* The outdated C macro ``_PyGC_FINALIZED()`` is no longer used in Py3.9+.

* The deprecated ``Py_OptimizeFlag`` is no longer used in Python 3.9+.
  (Github issue :issue:`5343`)

* Using the global ``__debug__`` variable but not assertions could lead to compile errors.

* The broken HTML template support was removed from Tempita.
  (Github issue :issue:`3309`)


0.29.35 (2023-05-24)
====================

Bugs fixed
----------

* A garbage collection enabled subtype of a non-GC extension type could call into the
  deallocation function of the super type with GC tracking enabled.  This could lead
  to crashes during deallocation if GC was triggered on the type at the same time.
  (Github issue :issue:`5432`)

* Some C compile failures and crashes in CPython 3.12 were resolved.

* ``except + nogil`` was syntactically not allowed.
  ``except +nogil`` (i.e. defining a C++ exception handling function called ``nogil``)
  is now disallowed to prevent typos.
  (Github issue :issue:`5430`)

* A C compile failure in PyPy 3.10 was resolved.
  Patch by Matti Picus.  (Github issue :issue:`5408`)

* Cython modules now use PEP-489 multi-phase init by default in PyPy 3.9 and later.
  Original patch by Matti Picus.  (Github issue :issue:`5413`)

* API header files generated by different Cython versions can now be included in the
  same C file.
  (Github issue :issue:`5383`)

* Function signatures containing a type like `tuple[()]` could not be printed.
  Patch by Lisandro Dalcin.  (Github issue :issue:`5355`)


0.29.34 (2023-04-02)
====================

Bugs fixed
----------

* A refence leak of the for-loop list/tuple iterable was resolved if the for-loop's
  ``else:`` branch executes a ``break`` for an outer loop.
  (Github issue :issue:`5347`)

* Some C compile failures in CPython 3.12 were resolved.

* Some old usages of the deprecated Python ``imp`` module were replaced with ``importlib``.
  Patch by Matúš Valo.  (Github issue :issue:`5300`)

* Some issues with ``depfile`` generation were resolved.
  Patches by Eli Schwartz.  (Github issues :issue:`5279`, :issue:`5291`)


0.29.33 (2023-01-06)
====================

Features added
--------------

* The ``cythonize`` and ``cython`` commands have a new option ``-M`` / ``--depfile``
  to generate ``.dep`` dependency files for the compilation unit.  This can be used
  by external build tools to track these dependencies.
  The ``cythonize`` option was already available in Cython :ref:`0.29.27`.
  Patches by Evgeni Burovski and Eli Schwartz.  (Github issue :issue:`1214`)

Bugs fixed
----------

* ``const`` fused types could not be used with memory views.
  Patch by Thomas Vincent.  (Github issue :issue:`1772`)

* ``wstr`` usage was removed in Python 3.12 and later (PEP-623).
  (Github issue :issue:`5145`)

* A type check assertion for Cython functions failed in debug Python builds.
  (Github issue :issue:`5031`)

* Fixed various compiler warnings.
  Patches by Lisandro Dalcin et al.  (Github issues :issue:`4948`, :issue:`5086`)

* Fixed error when calculating complex powers of negative numbers.
  (Github issue :issue:`5014`)
  
* Corrected a small mis-formatting of exception messages on Python 2.
  (Github issue :issue:`5018`)

* The ``PyUnicode_AsUTF8AndSize()`` C-API function was missing from the CPython declarations.
  (Github issue :issue:`5163`)

* A performance problem in the compiler was resolved when nesting conditional expressions.
  (Github issue :issue:`5197`)

* Test suite problems with recent NumPy and CPython versions were resolved.
  (Github issues :issue:`5183`, :issue:`5190`)

Other changes
-------------
  
* The undocumented, untested and apparently useless syntax
  ``from somemodule cimport class/struct/union somename`` was deprecated
  in anticipation of its removal in Cython 3.  The type
  modifier is not needed here and a plain ``cimport`` of the name will do.
  (Github issue :issue:`4905`)
  
* Properly disable generation of descriptor docstrings on PyPy since they cause crashes.
  It was previously disabled, but only accidentally via a typo.
  Patch by Matti Picus.  (Github issue :issue:`5083`)

* The ``cpow`` directive of Cython 3.0 is available as a no-op.
  (Github issue :issue:`5016`)


0.29.32 (2022-07-29)
====================

Bugs fixed
----------

* Revert "Using memoryview typed arguments in inner functions is now rejected as unsupported."
  Patch by David Woods.  (Github issue #4798)

* ``from module import *`` failed in 0.29.31 when using memoryviews.
  Patch by David Woods.  (Github issue #4927)


0.29.31 (2022-07-27)
====================

Features added
--------------

* A new argument ``--module-name`` was added to the ``cython`` command to
  provide the (one) exact target module name from the command line.
  Patch by Matthew Brett and h-vetinari.  (Github issue #4906)
  
* A new keyword ``noexcept`` was added for forward compatibility with Cython 3.
  Patch by David Woods.  (Github issue #4903)

Bugs fixed
----------

* Use ``importlib.util.find_spec()`` instead of the deprecated ``importlib.find_loader()``
  function when setting up the package path at import-time.
  Patch by Matti Picus.  (Github issue #4764)

* Require the C compiler to support the two-arg form of ``va_start``
  on Python 3.10 and higher.
  Patch by Thomas Caswell.  (Github issue #4820)

* Make ``fused_type`` subscriptable in Shadow.py.
  Patch by Pfebrer.  (Github issue #4842)

* Fix the incorrect code generation of the target type in ``bytearray`` loops.
  Patch by Kenrick Everett.  (Github issue #4108)

* Atomic refcounts for memoryviews were not used on some GCC versions by accident.
  Patch by Sam Gross.  (Github issue #4915)

* Silence some GCC ``-Wconversion`` warnings in C utility code.
  Patch by Lisandro Dalcin.  (Github issue #4854)

* Tuple multiplication was ignored in expressions such as ``[*(1,) * 2]``.
  Patch by David Woods.  (Github issue #4864)

* Calling ``append`` methods on extension types could fail to find the method
  in some cases.
  Patch by David Woods.  (Github issue #4828)

* Ensure that object buffers (e.g. ``ndarray[object, ndim=1]``) containing
  ``NULL``  pointers are safe to use, returning ``None`` instead of the ``NULL``
  pointer.
  Patch by Sebastian Berg.  (Github issue #4859)

* Using memoryview typed arguments in inner functions is now rejected as unsupported.
  Patch by David Woods.  (Github issue #4798)

* Compilation could fail on systems (e.g. FIPS) that block MD5 checksums at runtime.
  (Github issue #4909)

* Experimental adaptations for the CPython "nogil" fork was added.
  Note that there is no official support for this in Cython 0.x.
  Patch by Sam Gross.  (Github issue #4912)


0.29.30 (2022-05-16)
====================

Bugs fixed
----------

* The GIL handling changes in 0.29.29 introduced a regression where
  objects could be deallocated without holding the GIL.
  (Github issue #4796)


0.29.29 (2022-05-16)
====================

Features added
--------------

* Avoid acquiring the GIL at the end of nogil functions.
  This change was backported in order to avoid generating wrong C code
  that would trigger C compiler warnings with tracing support enabled.
  Backport by Oleksandr Pavlyk.  (Github issue #4637)

Bugs fixed
----------

* Function definitions in ``finally:`` clauses were not correctly generated.
  Patch by David Woods.  (Github issue #4651)

* A case where C-API functions could be called with a live exception set was fixed.
  Patch by Jakub Kulík.  (Github issue #4722)

* Pickles can now be exchanged again with those generated from Cython 3.0 modules.
  (Github issue #4680)

* Cython now correctly generates Python methods for both the provided regular and
  reversed special numeric methods of extension types.
  Patch by David Woods.  (Github issue #4750)

* Calling unbound extension type methods without arguments could raise an
  ``IndexError`` instead of a ``TypeError``.
  Patch by David Woods.  (Github issue #4779)

* Calling unbound ``.__contains__()`` super class methods on some builtin base
  types could trigger an infinite recursion.
  Patch by David Woods.  (Github issue #4785)

* The C union type in pure Python mode mishandled some field names.
  Patch by Jordan Brière.  (Github issue #4727)

* Allow users to overwrite the C macro ``_USE_MATH_DEFINES``.
  Patch by Yuriy Chernyshov. (Github issue #4690)

* Improved compatibility with CPython 3.10/11.
  Patches by Thomas Caswell, David Woods.  (Github issues #4609, #4667, #4721, #4730, #4777)

* Docstrings of descriptors are now provided in PyPy 7.3.9.
  Patch by Matti Picus.  (Github issue #4701)


0.29.28 (2022-02-17)
====================

Bugs fixed
----------

* Due to backwards incompatible changes in CPython 3.11a4, the feature flags
  ``CYTHON_FAST_THREAD_STATE`` and ``CYTHON_USE_EXC_INFO_STACK`` are now disabled
  in Python 3.11 and later.  They are enabled again in Cython 3.0.
  Patch by David Woods.  (Github issue #4610)

* A C compiler warning in older PyPy versions was resolved.
  Patch by Matti Picus.  (Github issue #4236)


0.29.27 (2022-01-28)
====================

Features added
--------------

* The ``cythonize`` command has a new option ``-M`` to generate ``.dep`` dependency
  files for the compilation unit.  This can be used by external build tools to track
  these dependencies.
  Patch by Evgeni Burovski.  (Github issue #1214)

Bugs fixed
----------

* Compilation failures on PyPy were resolved.
  Patches by Matti Picus.  (Github issues #4509, #4517)

* Calls to ``range()`` with more than three arguments did not fail.
  Original patch by Max Bachmann.  (Github issue #4550)

* Some C compiler warnings about missing type struct initialisers in Py3.10 were resolved.

* Cython no longer warns about using OpenMP 3.0 features since they are now
  considered generally available.


0.29.26 (2021-12-16)
====================

Bugs fixed
----------

* An incompatibility with CPython 3.11.0a3 was resolved.
  (Github issue #4499)

* The ``in`` operator failed on literal lists with starred expressions.
  Patch by Arvind Natarajan.  (Github issue #3938)

* A C compiler warning in PyPy about a missing struct field initialisation was resolved.


0.29.25 (2021-12-06)
====================

Bugs fixed
----------

* Several incompatibilities with CPython 3.11 were resolved.
  Patches by David Woods, Victor Stinner, Thomas Caswell.
  (Github issues #4411, #4414, #4415, #4416, #4420, #4428, #4473, #4479, #4480)

* Some C compiler warnings were resolved.
  Patches by Lisandro Dalcin and others.  (Github issue #4439)

* C++ ``std::move()`` should only be used automatically in MSVC versions that support it.
  Patch by Max Bachmann.  (Github issue #4191)

 * The ``Py_hash_t`` type failed to accept arbitrary "index" values.
   (Github issue #2752)

* Avoid copying unaligned 16-bit values since some platforms require them to be aligned.
  Use memcpy() instead to let the C compiler decide how to do it.
  (Github issue #4343)

* Cython crashed on invalid truthiness tests on C++ types without ``operator bool``.
  Patch by David Woods.  (Github issue #4348)

* The declaration of ``PyUnicode_CompareWithASCIIString()`` in ``cpython.unicode`` was incorrect.
  Patch by Max Bachmann.  (Github issue #4344)


0.29.24 (2021-07-14)
====================

Bugs fixed
----------

* Inline functions in pxd files that used memory views could lead to invalid
  C code if the module that imported from them does not use memory views.
  Patch by David Woods.  (Github issue #1415)

* Several declarations in ``libcpp.string`` were added and corrected.
  Patch by Janek Bevendorff.  (Github issue #4268)

* Pickling unbound Cython compiled methods failed.
  Patch by Pierre Glaser.  (Github issue #2972)

* The tracing code was adapted to work with CPython 3.10.

* The optimised ``in`` operator failed on unicode strings in Py3.9 and later
  that were constructed from an external ``wchar_t`` source.
  Also, related C compiler warnings about deprecated C-API usage were resolved.
  (Github issue #3925)

* Some compiler crashes were resolved.
  Patch by David Woods.  (Github issues #4214, #2811)

* An incorrect warning about 'unused' generator expressions was removed.
  (GIthub issue #1699)

* The attributes ``gen.gi_frame`` and ``coro.cr_frame`` of Cython compiled
  generators and coroutines now return an actual frame object for introspection,
  instead of ``None``.
  (Github issue #2306)


0.29.23 (2021-04-14)
====================

Bugs fixed
----------

* Some problems with Python 3.10 were resolved.
  Patches by Victor Stinner and David Woods.  (Github issues #4046, #4100)

* An incorrect "optimisation" was removed that allowed changes to a keyword
  dict to leak into keyword arguments passed into a function.
  Patch by Peng Weikang.  (Github issue #3227)

* Multiplied str constants could end up as bytes constants with language_level=2.
  Patch by Alphadelta14 and David Woods.  (Github issue #3951)

* ``PY_SSIZE_T_CLEAN`` does not get defined any more if it is already defined.
  Patch by Andrew Jones.  (Github issue #4104)


0.29.22 (2021-02-20)
====================

Features added
--------------

* Some declarations were added to the provided pxd includes.
  Patches by Zackery Spytz and John Kirkham.
  (Github issues #3811, #3882, #3899, #3901)

Bugs fixed
----------

* A crash when calling certain functions in Py3.9 and later was resolved.
  (Github issue #3917)

* ``const`` memory views of structs failed to compile.
  (Github issue #2251)

* ``const`` template declarations could not be nested.
  Patch by Ashwin Srinath.  (Github issue #1355)

* The declarations in the ``cpython.pycapsule`` module were missing their
  ``const`` modifiers and generated incorrect C code.
  Patch by Warren Weckesser.  (Github issue #3964)

* Casts to memory views failed for fused dtypes.
  Patch by David Woods.  (Github issue #3881)

* ``repr()`` was assumed to return ``str`` instead of ``unicode`` with ``language_level=3``.
  (Github issue #3736)

* Calling ``cpdef`` functions from cimported modules crashed the compiler.
  Patch by David Woods.  (Github issue #4000)

* Cython no longer validates the ABI size of the NumPy classes it compiled against.
  See the discussion in https://github.com/numpy/numpy/pull/432

* A C compiler warning about enum value casting was resolved in GCC.
  (Github issue #2749)

* Coverage reporting in the annotated HTML file failed in Py3.9.
  Patch by Nick Pope.  (Github issue #3865)

* The embedding code now reports Python errors as exit status.

* Long type declarations could lead to (harmless) random changes in the
  C file when used in auto-generated Python wrappers or pickled classes.

Other changes
-------------

* Variables defined as ``cpdef`` now generate a warning since this
  is currently useless and thus does not do what users would expect.
  Patch by David Woods.  (Github issue #3959)


0.29.21 (2020-07-09)
====================

Bugs fixed
----------

* Fix a regression in 0.29.20 where ``__div__`` failed to be found in extension types.
  (Github issue #3688)

* Fix a regression in 0.29.20 where a call inside of a finally clause could fail to compile.
  Patch by David Woods.  (Github issue #3712)

* Zero-sized buffers could fail to validate as C/Fortran-contiguous.
  Patch by Clemens Hofreither.  (Github issue #2093)

* ``exec()`` did not allow recent Python syntax features in Py3.8+ due to
  https://bugs.python.org/issue35975.
  (Github issue #3695)

* Binding staticmethods of Cython functions were not behaving like Python methods in Py3.
  Patch by Jeroen Demeyer and Michał Górny.  (Github issue #3106)

* Pythran calls to NumPy methods no longer generate useless method lookup code.

* The ``PyUnicode_GET_LENGTH()`` macro was missing from the ``cpython.*`` declarations.
  Patch by Thomas Caswell.  (Github issue #3692)

* The deprecated ``PyUnicode_*()`` C-API functions are no longer used, except for Unicode
  strings that contain lone surrogates.  Unicode strings that contain non-BMP characters
  or surrogate pairs now generate different C code on 16-bit Python 2.x Unicode deployments
  (such as MS-Windows).  Generating the C code on Python 3.x is recommended in this case.
  Original patches by Inada Naoki and Victor Stinner.  (Github issues #3677, #3721, #3697)

* Some template parameters were missing from the C++ ``std::unordered_map`` declaration.
  Patch by will.  (Github issue #3685)

* Several internal code generation issues regarding temporary variables were resolved.
  (Github issue #3708)


0.29.20 (2020-06-10)
====================

Bugs fixed
----------

* Nested try-except statements with multiple ``return`` statements could crash
  due to incorrect deletion of the ``except as`` target variable.
  (Github issue #3666)

* The ``@classmethod`` decorator no longer rejects unknown input from other decorators.
  Patch by David Woods.  (Github issue #3660)

* Fused types could leak into unrelated usages.
  Patch by David Woods.  (Github issue #3642)

* Now uses ``Py_SET_SIZE()`` and ``Py_SET_REFCNT()`` in Py3.9+ to avoid low-level
  write access to these object fields.
  Patch by Victor Stinner.  (Github issue #3639)

* The built-in ``abs()`` function could lead to undefined behaviour when used on
  the negative-most value of a signed C integer type.
  Patch by Serge Guelton.  (Github issue #1911)

* Usages of ``sizeof()`` and ``typeid()`` on uninitialised variables no longer
  produce a warning.
  Patch by Celelibi.  (Github issue #3575)

* The C++ ``typeid()`` function was allowed in C mode.
  Patch by Celelibi.  (Github issue #3637)

* The error position reported for errors found in f-strings was misleading.
  (Github issue #3674)

* The new ``c_api_binop_methods`` directive was added for forward compatibility, but can
  only be set to True (the current default value).  It can be disabled in Cython 3.0.


0.29.19 (2020-05-20)
====================

Bugs fixed
----------

* A typo in Windows specific code in 0.29.18 was fixed that broke "libc.math".
  (Github issue #3622)

* A platform specific test failure in 0.29.18 was fixed.
  Patch by smutch.  (Github issue #3620)


0.29.18 (2020-05-18)
====================

Bugs fixed
----------

* Exception position reporting could run into race conditions on threaded code.
  It now uses function-local variables again.

* Error handling early in the module init code could lead to a crash.

* Error handling in ``cython.array`` creation was improved to avoid calling
  C-API functions with an error held.

* A memory corruption was fixed when garbage collection was triggered during calls
  to ``PyType_Ready()`` of extension type subclasses.
  (Github issue #3603)

* Memory view slicing generated unused error handling code which could negatively
  impact the C compiler optimisations for parallel OpenMP code etc.  Also, it is
  now helped by static branch hints.
  (Github issue #2987)

* Cython's built-in OpenMP functions were not translated inside of call arguments.
  Original patch by Celelibi and David Woods.  (Github issue #3594)

* Complex buffer item types of structs of arrays could fail to validate.
  Patch by Leo and smutch.  (Github issue #1407)

* Decorators were not allowed on nested `async def` functions.
  (Github issue #1462)

* C-tuples could use invalid C struct casting.
  Patch by MegaIng.  (Github issue #3038)

* Optimised ``%d`` string formatting into f-strings failed on float values.
  (Github issue #3092)

* Optimised aligned string formatting (``%05s``, ``%-5s``) failed.
  (Github issue #3476)

* When importing the old Cython ``build_ext`` integration with distutils, the
  additional command line arguments leaked into the regular command.
  Patch by Kamekameha.  (Github issue #2209)

* When using the ``CYTHON_NO_PYINIT_EXPORT`` option in C++, the module init function
  was not declared as ``extern "C"``.
  (Github issue #3414)

* Three missing timedelta access macros were added in ``cpython.datetime``.

* The signature of the NumPy C-API function ``PyArray_SearchSorted()`` was fixed.
  Patch by Brock Mendel.  (Github issue #3606)


0.29.17 (2020-04-26)
====================

Features added
--------------

* ``std::move()`` is now available from ``libcpp.utility``.
  Patch by Omer Ozarslan.  (Github issue #2169)

* The ``@cython.binding`` decorator is available in Python code.
  (Github issue #3505)

Bugs fixed
----------

* Creating an empty unicode slice with large bounds could crash.
  Patch by Sam Sneddon.  (Github issue #3531)

* Decoding an empty bytes/char* slice with large bounds could crash.
  Patch by Sam Sneddon.  (Github issue #3534)

* Re-importing a Cython extension no longer raises the error
  "``__reduce_cython__ not found``".
  (Github issue #3545)

* Unused C-tuples could generate incorrect code in 0.29.16.
  Patch by Kirk Meyer.  (Github issue #3543)

* Creating a fused function attached it to the garbage collector before it
  was fully initialised, thus risking crashes in rare failure cases.
  Original patch by achernomorov.  (Github issue #3215)

* Temporary buffer indexing variables were not released and could show up in
  C compiler warnings, e.g. in generators.
  Patch by David Woods.  (Github issues #3430, #3522)

* The compilation cache in ``cython.inline("…")`` failed to take the language
  level into account.
  Patch by will-ca.  (Github issue #3419)

* The deprecated ``PyUnicode_GET_SIZE()`` function is no longer used in Py3.


0.29.16 (2020-03-24)
====================

Bugs fixed
----------

* Temporary internal variables in nested prange loops could leak into other
  threads.  Patch by Frank Schlimbach.  (Github issue #3348)

* Default arguments on fused functions could crash.
  Patch by David Woods.  (Github issue #3370)

* C-tuples declared in ``.pxd`` files could generate incomplete C code.
  Patch by Kirk Meyer.  (Github issue #1427)

* Fused functions were not always detected and optimised as Cython
  implemented functions.
  Patch by David Woods.  (Github issue #3384)

* Valid Python object concatenation of (iterable) strings to non-strings
  could fail with an exception.
  Patch by David Woods.  (Github issue #3433)

* Using C functions as temporary values lead to invalid C code.
  Original patch by David Woods.  (Github issue #3418)

* Fix an unhandled C++ exception in comparisons.
  Patch by David Woods.  (Github issue #3361)

* Fix deprecated import of "imp" module.
  Patch by Matti Picus.  (Github issue #3350)

* Fix compatibility with Pythran 0.9.6 and later.
  Patch by Serge Guelton.  (Github issue #3308)

* The ``_Py_PyAtExit()`` function in ``cpython.pylifecycle`` was misdeclared.
  Patch by Zackery Spytz.  (Github issue #3382)

* Several missing declarations in ``cpython.*`` were added.
  Patches by Zackery Spytz.  (Github issue #3452, #3421, #3411, #3402)

* A declaration for ``libc.math.fpclassify()`` was added.
  Patch by Zackery Spytz.  (Github issue #2514)

* Avoid "undeclared" warning about automatically generated pickle methods.
  Patch by David Woods.  (Github issue #3353)

* Avoid C compiler warning about unreachable code in ``prange()``.

* Some C compiler warnings in PyPy were resolved.
  Patch by Matti Picus.  (Github issue #3437)


0.29.15 (2020-02-06)
====================

Bugs fixed
----------

* Crash when returning a temporary Python object from an async-def function.
  (Github issue #3337)

* Crash when using ``**kwargs`` in generators.
  Patch by David Woods.  (Github issue #3265)

* Double reference free in ``__class__`` cell handling for ``super()`` calls.
  (Github issue #3246)

* Compile error when using ``*args`` as Python class bases.
  (Github issue #3338)

* Import failure in IPython 7.11.
  (Github issue #3297)

* Fixed C name collision in the auto-pickle code.
  Patch by ThePrez.  (Github issue #3238)

* Deprecated import failed in Python 3.9.
  (Github issue #3266)


0.29.14 (2019-11-01)
====================

Bugs fixed
----------

* The generated code failed to initialise the ``tp_print`` slot in CPython 3.8.
  Patches by Pablo Galindo and Orivej Desh.  (Github issues #3171, #3201)

* ``?`` for ``bool`` was missing from the supported NumPy dtypes.
  Patch by Max Klein.  (Github issue #2675)

* ``await`` was not allowed inside of f-strings.
  Patch by Dmitro Getz.  (Github issue #2877)

* Coverage analysis failed for projects where the code resides in separate
  source sub-directories.
  Patch by Antonio Valentino.  (Github issue #1985)

* An incorrect compiler warning was fixed in automatic C++ string conversions.
  Patch by Gerion Entrup.  (Github issue #3108)

* Error reports in the Jupyter notebook showed unhelpful stack traces.
  Patch by Matthew Edwards (Github issue #3196).

* ``Python.h`` is now also included explicitly from ``public`` header files.
  (Github issue #3133).

* Distutils builds with ``--parallel`` did not work when using Cython's
  deprecated ``build_ext`` command.
  Patch by Alphadelta14 (Github issue #3187).

Other changes
-------------

* The ``PyMemoryView_*()`` C-API is available in ``cpython.memoryview``.
  Patch by Nathan Manville.  (Github issue #2541)


0.29.13 (2019-07-26)
====================

Bugs fixed
----------

* A reference leak for ``None`` was fixed when converting a memoryview
  to a Python object.  (Github issue #3023)

* The declaration of ``PyGILState_STATE`` in ``cpython.pystate`` was unusable.
  Patch by Kirill Smelkov.  (Github issue #2997)


Other changes
-------------

* The declarations in ``posix.mman`` were extended.
  Patches by Kirill Smelkov.  (Github issues #2893, #2894, #3012)


0.29.12 (2019-07-07)
====================

Bugs fixed
----------

* Fix compile error in CPython 3.8b2 regarding the ``PyCode_New()`` signature.
  (Github issue #3031)

* Fix a C compiler warning about a missing ``int`` downcast.
  (Github issue #3028)

* Fix reported error positions of undefined builtins and constants.
  Patch by Orivej Desh.  (Github issue #3030)

* A 32 bit issue in the Pythran support was resolved.
  Patch by Serge Guelton.  (Github issue #3032)


0.29.11 (2019-06-30)
====================

Bugs fixed
----------

* Fix compile error in CPython 3.8b2 regarding the ``PyCode_New()`` signature.
  Patch by Nick Coghlan. (Github issue #3009)

* Invalid C code generated for lambda functions in cdef methods.
  Patch by Josh Tobin.  (Github issue #2967)

* Support slice handling in newer Pythran versions.
  Patch by Serge Guelton.  (Github issue #2989)

* A reference leak in power-of-2 calculation was fixed.
  Patch by Sebastian Berg.  (Github issue #3022)

* The search order for include files was changed. Previously it was
  ``include_directories``, ``Cython/Includes``, ``sys.path``. Now it is
  ``include_directories``, ``sys.path``, ``Cython/Includes``. This was done to
  allow third-party ``*.pxd`` files to override the ones in Cython.
  Original patch by Matti Picus.  (Github issue #2905)

* Setting ``language_level=2`` in a file did not work if ``language_level=3``
  was enabled globally before.
  Patch by Jeroen Demeyer.  (Github issue #2791)


0.29.10 (2019-06-02)
====================

Bugs fixed
----------

* Fix compile errors in CPython 3.8b1 due to the new "tp_vectorcall" slots.
  (Github issue #2976)


0.29.9 (2019-05-29)
===================

Bugs fixed
----------

* Fix a crash regression in 0.29.8 when creating code objects fails.

* Remove an incorrect cast when using true-division in C++ operations.
  (Github issue #1950)


0.29.8 (2019-05-28)
===================

Bugs fixed
----------

* C compile errors with CPython 3.8 were resolved.
  Patch by Marcel Plch.  (Github issue #2938)

* Python tuple constants that compare equal but have different item
  types could incorrectly be merged into a single constant.
  (Github issue #2919)

* Non-ASCII characters in unprefixed strings could crash the compiler when
  used with language level ``3str``.

* Starred expressions in %-formatting tuples could fail to compile for
  unicode strings.  (Github issue #2939)

* Passing Python class references through ``cython.inline()`` was broken.
  (Github issue #2936)


0.29.7 (2019-04-14)
===================

Bugs fixed
----------

* Crash when the shared Cython config module gets unloaded and another Cython
  module reports an exceptions.  Cython now makes sure it keeps an owned reference
  to the module.
  (Github issue #2885)

* Resolved a C89 compilation problem when enabling the fast-gil sharing feature.

* Coverage reporting did not include the signature line of ``cdef`` functions.
  (Github issue #1461)

* Casting a GIL-requiring function into a nogil function now issues a warning.
  (Github issue #2879)

* Generators and coroutines were missing their return type annotation.
  (Github issue #2884)


0.29.6 (2019-02-27)
===================

Bugs fixed
----------

* Fix a crash when accessing the ``__kwdefaults__`` special attribute of
  fused functions.  (Github issue #1470)

* Fix the parsing of buffer format strings that contain numeric sizes, which
  could lead to incorrect input rejections.  (Github issue #2845)

* Avoid a C #pragma in old gcc versions that was only added in GCC 4.6.
  Patch by Michael Anselmi.  (Github issue #2838)

* Auto-encoding of Unicode strings to UTF-8 C/C++ strings failed in Python 3,
  even though the default encoding there is UTF-8.
  (Github issue #2819)


0.29.5 (2019-02-09)
===================

Bugs fixed
----------

* Crash when defining a Python subclass of an extension type and repeatedly calling
  a cpdef method on it.  (Github issue #2823)

* Compiler crash when ``prange()`` loops appear inside of with-statements.
  (Github issue #2780)

* Some C compiler warnings were resolved.
  Patches by Christoph Gohlke.  (Github issues #2815, #2816, #2817, #2822)

* Python conversion of C++ enums failed in 0.29.
  Patch by Orivej Desh.  (Github issue #2767)


0.29.4 (2019-02-01)
===================

Bugs fixed
----------

* Division of numeric constants by a runtime value of 0 could fail to raise a
  ``ZeroDivisionError``.  (Github issue #2820)


0.29.3 (2019-01-19)
===================

Bugs fixed
----------

* Some C code for memoryviews was generated in a non-deterministic order.
  Patch by Martijn van Steenbergen.  (Github issue #2779)

* C89 compatibility was accidentally lost since 0.28.
  Patches by gastineau and true-pasky.  (Github issues #2778, #2801)

* A C compiler cast warning was resolved.
  Patch by Michael Buesch.  (Github issue #2774)

* An compilation failure with complex numbers under MSVC++ was resolved.
  (Github issue #2797)

* Coverage reporting could fail when modules were moved around after the build.
  Patch by Wenjun Si.  (Github issue #2776)


0.29.2 (2018-12-14)
===================

Bugs fixed
----------

* The code generated for deduplicated constants leaked some references.
  (Github issue #2750)

* The declaration of ``sigismember()`` in ``libc.signal`` was corrected.
  (Github issue #2756)

* Crashes in compiler and test runner were fixed.
  (Github issue #2736, #2755)

* A C compiler warning about an invalid safety check was resolved.
  (Github issue #2731)


0.29.1 (2018-11-24)
===================
